// DEPRECATED
// 现在socket链接改在页面发起
const io = require('ws');
const config = require('./config');

const skUrl = `ws://127.0.0.1:${config.gatewayPort}/websocket/subscriptionTaskSync`;
let socket;
function initialWebsocket(onMessage, onError, onClose) {
  socket = new io(skUrl);
  socket.on('open', () => {
    // socket.emit("hello", "world");
    console.log('socket connection');
    // socket.send('1');
  });
  socket.on('message', (message) => {
    // console.log('socket message', message);
    onMessage(message);
  });
  socket.on('error', (...args) => {
    console.log('socket error:', args);
    onError && onError(...args);
  });
  socket.on('close', (...args) => {
    console.log('socket close:', args);
    onClose && onClose(...args);
    setTimeout(() => initialWebsocket(onMessage, onError, onClose), 5000);
  });
}

module.exports.initialWebsocketEvents = function initialWebsocketEvents(
  ipcMain,
  onMessage,
  onError,
  onClose,
) {
  initialWebsocket(onMessage, onError, onClose);
  ipcMain.handle('socket:send-message', (event, message) => {
    if (socket && socket.readyState === io.OPEN) {
      console.log('socket send message to gateway:', message);
      socket.send(message);
    } else {
      console.log('socket status not ready:', socket.readyState);
    }
  });
};
